<template>
    <v-form ref="form" v-model="valid" lazy-validation>
        <v-row>
          <v-col cols="12 pb-0">
              <v-text-field
              v-model="email"
              name="email"
              label="Enter email"
              :rules="emailRules"
              outlined
              />
          </v-col>
          <v-col cols="12 pb-0">
              <v-text-field
              v-model="password"
              label="Enter password"
              type="password"
              name="password"
              :rules="passwordRules"
              outlined
              @keyup.enter="login"
              />
          </v-col>
          <v-col v-if="authErrorMessages" cols="12">
              <p style="color: red">{{ authErrorMessages }}</p>
          </v-col>
          <v-col cols="12">
              <v-btn :loading="loading" outlined block large @click="login"
              >Login</v-btn
              >
          </v-col>
          <v-col xs="12" sm="12" md="12">
              <router-link to="/forgot-password"
              ><p class="body-1">Forgot password?</p></router-link
              >
              <p class="body-1">
              Don't have an account?
              <router-link to="/sign-up">Sign up</router-link>
              </p>
          </v-col>
        </v-row>
    </v-form>
</template>

<script>
import { mapState, mapGetters } from 'vuex'
import { isNil } from 'lodash'

export default {
  data: () => ({
    email: '',
    password: '',
    valid: false,
    emailRules: [
      v => !!v || 'E-mail is required',
      v => /.+@.+/.test(v) || 'E-mail must be valid'
    ],
    passwordRules: [
      v => !!v || 'Password is required',
      v => v.length >= 6 || 'Password must be greater than 6 characters'
    ],
    userFirstLastName: {},
    loading: false
  }),
  computed: {
    ...mapState('authentication', ['user', 'authErrorMessages']),
    ...mapState('app', ['networkOnLine', 'appTitle']),
    ...mapGetters('authentication', ['isUserLoggedIn'])
  },
  watch: {
    user: {
      handler(user) {
        if (!isNil(user)) {
          const redirectUrl = isNil(this.$route.query.redirectUrl)
            ? '/'
            : this.$route.query.redirectUrl
          this.$router.push(redirectUrl)
        }
      },
      immediate: true
    }
  },
  mounted() {
    if (this.isUserLoggedIn) {
      this.$router.push('/dashboard')
    }
  },
  beforeDestroy() {
    this.$store.dispatch('authentication/clearAuthErrors')
  },
  methods: {
    login() {
      if (this.$refs.form.validate()) {
        this.loading = true
        this.$store
          .dispatch('authentication/login', {
            email: this.email,
            password: this.password
          })
          .then(() => {
            this.loading = false
          })
          .catch(() => (this.loading = false))
      }
    }
  }
}
</script>

<style lang="scss" scoped>
@import '@/sass/variables.scss';

.page-wrapper {

  .login-page-title {
    text-align: center;
  }

  .login-btn {
    margin-top: 20px;
    cursor: pointer;
    padding: 5px 20px;
    border: 1px solid;
    display: inline-block;
    border-radius: 3px;
    border-color: #2c3e50;

    &:hover {
      color: $vue-color;
      border-color: $vue-color;
    }
  }
  .text-or {
    font-size: 18px;
    color: grey;
  }
}
</style>
